/*
******************************************************************************
 *
 * GGI_ART pixel stubs - initialization.
 * 
 * Copyright (C) 2001 Eric Faurot
 *
******************************************************************************
*/

#include <libart_lgpl/libart.h>

#include "artstubs.h"
#include "ggiart_debug.h"

/* init */

static int 
GGIARTopen(ggi_visual *vis, struct ggi_dlhandle *dlh,
	    const char *args, void *argptr, uint32 *dlret) {
  GGIARTDPRINT_CORE("GGIARTopen(%p, %p, %s, %p, %p) called for stubs sublib\n",
		    vis, dlh, args ? args : "(NULL)", argptr, dlret);
  
  /*
    STUBSART_PRIV(vis) = malloc(sizeof(struct stubsart_priv));
    if (STUBSART_PRIV(vis) == NULL) 
    {
    ARTDPRINT_CORE("Returning %i\n", GGI_ENODEVICE);
    return GGI_ENODEVICE;
    }
  */

  LIBGGI_GGIARTEXT(vis)->render_svp=GGIART_stubs_render_svp;
  LIBGGI_GGIARTEXT(vis)->render_buffer=GGIART_stubs_render_buffer;
  LIBGGI_GGIARTEXT(vis)->fillscreen=GGIART_stubs_fillscreen;
  GGIARTDPRINT("default-stubs: GGIdlinit success.\n");
  
  *dlret = GGI_DL_EXTENSION;
  return 0;
}


static int
GGIARTclose(ggi_visual *vis, struct ggi_dlhandle *dlh) {
  GGIARTDPRINT_CORE("GGIARTclose(%p, %p) called for stubs sublib\n", vis, dlh);
  
  return 0;
}

int
GGIARTdl_stubs(int func, void **funcptr) {
  GGIARTDPRINT_CORE("GGI_ARTdl_stubs()\n");
  
  switch (func) {
  case GGIFUNC_open:
    *funcptr = GGIARTopen;
    return 0;
  case GGIFUNC_exit:
    *funcptr = NULL;
    return 0;
  case GGIFUNC_close:
    *funcptr = GGIARTclose;
    return 0;
  default:
    *funcptr = NULL;
  }
  
  return GGI_ENOTFOUND;
}

/* This should be included by exactly _one_ file in each sublib. */
#include <ggi/internal/ggidlinit.h>
